/****************************************************************
*
*    Proprietary Data of Adapitve Networks Inc.
*              All rights reserved
*
* Notice:
*		This file contains trade secret data which
*		is the property of Adpative Networks Inc.  This
*		file may not be used for any purpose unless
*		permission is granted in writing by an officier
*		of Adapitve Networks Inc.
*
*
* Filename
*		version.h
*
* Description:
*		header file for the version numbers
*			- Cortex application
*			- DSP applications (6 cores)
*			- bootloader
*			- invesre bootloader (Ethernet and Serial)
*			- image version (the one that goes on the SPI flash)
*
* Revision History:
*	Khaled Saab	August 17th 2011	split from DSP1000.h
****************************************************************/
#ifndef _VERSION_H__
#define _VERSION_H__

//define the current code release version
//      8bits             8bits               8bits       8bits
//------------------------------------------------------------------
//| Adaptive Model # | Adaptive Sub Model # |Major Rev | Minor Rev |
//------------------------------------------------------------------
//Note: Adaptive Model and Sub Model # are pre-coded as follow:
//		0x0xxx reserved for  192 (legacy)
//		0x1xxx reserved for  192 (IEC)
//		0x2xxx reserved for   48
//		0x3xxx reserved for 1000
//
//		0x3x1x reserved for 1000/BPSK  (Phase1)
//		0x3x2x reserved for 1000/QAM   (Phase2)
//		0x3x3x reserved for 1000/MWB   (Phase3)
//
//		0x32xx reserved for 1000/CortexM4

#define DSP_VERSION_MODEL           0x03
#define DSP_VERSION_SUB_MODEL       0x02
#define DSP_VERSION_MAJOR           0x02
#define DSP_VERSION_MINOR           0x01
#define DSP_VERSION_MODEL_SHIFT     24
#define DSP_VERSION_SUB_MODEL_SHIFT 16
#define DSP_VERSION_MAJOR_SHIFT     8
#define DSP_VERSION_MINOR_SHIFT     0
#define DSP_VERSION_MODEL_MASK      0xFF000000
#define DSP_VERSION_SUB_MODEL_MASK  0x00FF0000
#define DSP_VERSION_MAJOR_MASK      0x0000FF00
#define DSP_VERSION_MINOR_MASK      0x000000FF


#define DSP_VERSION	((DSP_VERSION_MODEL << DSP_VERSION_MODEL_SHIFT) |\
                    (DSP_VERSION_SUB_MODEL << DSP_VERSION_SUB_MODEL_SHIFT) |\
                    (DSP_VERSION_MAJOR << DSP_VERSION_MAJOR_SHIFT) |\
                    (DSP_VERSION_MINOR << DSP_VERSION_MINOR_SHIFT))

#define IMAGE_VERSION               0x03020201
#define DSP_APP_VERSION             0x03020201
#define CORTEX_APP_VERSION          0x03020201
#define DIRECT_BOOT_VERSION         0x03020201
#define DIRECT_BOOT_LIB_VERSION     0x03020201
#define INV_BOOT_RS232_VERSION      0x03020201
#define INV_BOOT_ETHERNET_VERSION   0x03020201
#define PC_APPLICATION_VERSION      0x03020201
#define TESTBENCH_VERSION			0x03020201


#define DSP_BUILD_OPTIONS	0x0000	//custom build options and flags
#define PROTOCOL_VERSION	0x0001	//

#endif //_VERSION_H__
/*** end of file *****************************************************/
