
/****************************************************************
  *
  * Proprietary Data of Adaptive Networks, Inc.
  *              All rights reserved
  *
  * Notice:
  *        This file contains trade secret data which
  *        is the property of Adaptive Networks, Inc.  This
  *        file may not be used for any purpose unless
  *        permission is granted in writing by an officer
  *        of Adaptive Networks, Inc.
  *
  *
  * Filename
  *        A_GPIO.c
  *
  * Description:
  *
  * Author:
  *
  * Revision History:
  *            Nov. 13 2009: Initial checkin
  *            Nov. 13 2008: added xxxxx
  ****************************************************************/
#include <stdbool.h>
#include <stdint.h>
#include <utils/uartstdio.h>

#include <inc/hw_memmap.h>		//base addresses
#include <inc/hw_types.h>
#include <inc/hw_sysctl.h>
#include <inc/hw_gpio.h>
#include <inc/hw_udma.h>
#include <inc/hw_epi.h>
#include <inc/hw_ints.h>
#include <inc/hw_types.h>
#include <inc/hw_watchdog.h>
#include <inc/hw_timer.h>

#include <driverlib/pin_map.h>
#include <driverlib/gpio.h>
#include <driverlib/watchdog.h>
#include <driverlib/sysctl.h>
#include <driverlib/timer.h>
#include <driverlib/debug.h>
#include <driverlib/epi.h>
#include <driverlib/interrupt.h>

#include "../Interfaces/A_GPIO.h"
#include "../../Shared/interfaces.h"

void GPIO_Init(void) {

    //--------------------------------------------------------------------
    //First makes sure all clocks are enabled.
    // Enable the clock to the appropriate GPIO modulel
    //--------------------------------------------------------------------
	SysCtlPeripheralEnable(SYSCTL_PERIPH_EMAC0);	//Ethernet
	SysCtlPeripheralReset(SYSCTL_PERIPH_EMAC0);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_EPHY0);
	SysCtlPeripheralReset(SYSCTL_PERIPH_EPHY0);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_UDMA);
	SysCtlPeripheralReset(SYSCTL_PERIPH_UDMA);


	SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);	//timer0 is used as an 10msec tick RTC
	SysCtlPeripheralReset(SYSCTL_PERIPH_TIMER0);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER1);	//timer1 is used by the modbus rootine
	SysCtlPeripheralReset(SYSCTL_PERIPH_TIMER1);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOA);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOB);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOC);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOD);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOE);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOF);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOG);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOG);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOH);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOH);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOJ);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOJ);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOK);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOK);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOL);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOL);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOM);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOM);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPION);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPION);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOP);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOP);

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOQ);
	SysCtlPeripheralReset(SYSCTL_PERIPH_GPIOQ);

	// Wait for the peripherals to be ready.
	while(!SysCtlPeripheralReady(SYSCTL_PERIPH_EMAC0)) { }
	while(!SysCtlPeripheralReady(SYSCTL_PERIPH_UDMA )) { };

	//---------------------------------------------------------------
	//configure JTAG pins
	//---------------------------------------------------------------
	GPIOPinConfigure(GPIO_PC0_TCK);	 	//JTAG TCK
	GPIOPinConfigure(GPIO_PC1_TMS);	 	//JTAG TMS
	GPIOPinConfigure(GPIO_PC2_TDI);	 	//JTAG TDI
	GPIOPinConfigure(GPIO_PC3_TDO);	 	//JTAG TDO

	//---------------------------------------------------------------
	//configure Ethernet pins
	//---------------------------------------------------------------
	GPIOPinConfigure(GPIO_PK5_EN0LED2);	//Ethernet Link
	GPIOPinConfigure(GPIO_PF4_EN0LED1);	//Ethernet Active


	//---------------------------------------------------------------
	//for each function pin, select the type
	//---------------------------------------------------------------
	GPIOPinTypeEthernetLED(GPIO_PORTK_BASE,
									GPIO_PIN_5);	//Ethernet link
	GPIOPinTypeEthernetLED(GPIO_PORTF_BASE,
									GPIO_PIN_4);	//Ethernet activity

}
