/****************************************************************
  *
  * Proprietary Data of Adaptive Networks, Inc.
  *              All rights reserved
  *
  * Notice:
  *        This file contains trade secret data which
  *        is the property of Adaptive Networks, Inc.  This
  *        file may not be used for any purpose unless
  *        permission is granted in writing by an officer
  *        of Adaptive Networks, Inc.
  *
  *
  * Filename
  *        A_uDMA.c
  *
  * Description:
  *
  * Author:
  *
  * Revision History:
  *            Nov. 13 2009: Initial checkin
  *            Nov. 13 2008: added xxxxx
  ****************************************************************/
#include <stdbool.h>		//bool
#include <stdint.h>			//declaration of uint8_t int16_t...

#include <inc/hw_types.h>
#include <inc/hw_ints.h>
#include <inc/hw_memmap.h>
#include <inc/hw_udma.h>
#include <driverlib/udma.h>
#include <driverlib/interrupt.h>

#include "../Interfaces/A_UDMA.h"

//-------------------------------------------------------------------------
// Global varialbes declaration
//-------------------------------------------------------------------------
//define the uDMA control table
#if defined(ewarm)
#pragma data_alignment=1024
unsigned char ucControlTable[1024];
#elif defined(ccs)
#pragma DATA_ALIGN(ucControlTable, 1024)
tDMAControlTable ucControlTable[1024];
#else
unsigned char ucControlTable[1024] __attribute__ ((aligned(1024)));
#endif


/**********************************************************************
* Function   : uDMA_Init()
* Description: Initialize the uDMA interface
* Inputs	 :
* Outputs	 :
* Return	 :
**********************************************************************/
void uDMA_Init(void) {
	//set the control table
	uDMAControlBaseSet(ucControlTable);
	//enable uDMA
	uDMAEnable();
	//setup the uDMA interrupts
	//Note: A_EPI.c has a note that we don't want the uDMA to generate
	//      an interrupt on conclusion! Do we rely on EPI_ADCtoDSP_start()
	//      function to disable the uDMA when needed?
	IntEnable(INT_UDMA);
	IntEnable(INT_UDMAERR);
}
/**********************************************************************
* Function   : UDMAERR_Handler
* Description: The interrupt handler for uDMA errors.  This interrupt
*              will occur if the uDMA encounters a bus error while
*              trying to perform a transfer.  This handler just
*              log the error.
* Inputs	 :
* Outputs	 :
* Return	 :
* Note       :
**********************************************************************/
void UDMAERR_Handler(void) {

    uint32_t status;

    // Check for uDMA error bit
    status = uDMAErrorStatusGet();

    // If there is a uDMA error, then clear the error and increment
    // the error counter.
    if(status) {
        uDMAErrorStatusClear();

//		__breakpoint(0);    //XXXX DEBUG : break execution - stop here forever
    }
}
void UDMA_Handler(void) {
	//we should never get to this function
	//but if we do...
}
