/**************************************************************************
*    Proprietary Data of Adapitve Networks Inc.
*              All rights reserved
*
* Notice:
*		This file contains trade secret data which
*		is the property of Adpative Networks Inc.  This
*		file may not be used for any purpose unless
*		permission is granted in writing by an officier
*		of Adapitve Networks Inc.
*
*
* Filename
*		main.c
*
* Description:
*		DSP1000 cortex main
*
* Revision History:
* Khaled Saab Jan  3th 2011	Creation of the file
* Khaled Saab Jul 21th 2016	Ported to Cortex M4
**************************************************************************/
#include <rtl.h>
#include <stdbool.h>
#include <stdint.h>					//declaration of uint8_t int8_t...
#include <stdlib.h> 				//rand

#include <inc/hw_ints.h>
#include <inc/hw_types.h>
#include <inc/hw_memmap.h>      	//base addresses
#include <inc/hw_sysctl.h>      	//sys control registers
#include <driverlib/gpio.h>
#include <driverlib/sysctl.h>   	//system clock
#include <driverlib/udma.h>
#include <driverlib/eeprom.h>		//interrupt enable/disable
#include <driverlib/interrupt.h>	//interrupt enable/disable

#include "../../Shared/DSP1000.h"
#include "../../Shared/dataAPI.h"
#include "../../Shared/packetAPI.h"
#include "../../Shared/queueAPI.h"

#include "../main/main.h"
#include "../main/system_TM4C129.h"
#include "../Interfaces/A_GPIO.h"
#include "../Interfaces/A_uDMA.h"
#include "../our_Drivers/taskMgr.h"
#include "../our_Drivers/Ethernet_Driver.h"

#ifndef BOOTLOADER
OS_MUT         gMutexFlag;			//Mutex
#endif

int main(void) {

	//-------------------------------------------------
	//Initialize the different drivers
	//-------------------------------------------------
	IntMasterDisable();
	SystemInit();  					//system setup
	packetInit();					//initialize the packets
	queueInit(); 					//initialize the queue head

	GPIO_Init();   					//setup GPIO
	uDMA_Init();   					//setup the uDMA

	Ethernet_AddressInit();			//setup the Ethernet Ip, Mac, Mask...
	Ethernet_Init();				//setup the Ethernet port

	//-------------------------------------------------
	//start the Kernel
	//-------------------------------------------------
	IntMasterEnable();

	os_sys_init(taskInit);
}
