/****************************************************************************
*    Proprietary Data of Adapitve Networks Inc.
*              All rights reserved
*
* Notice:
*		This file contains trade secret data which
*		is the property of Adpative Networks Inc.  This
*		file may not be used for any purpose unless
*		permission is granted in writing by an officier
*		of Adapitve Networks Inc.
*
*
* Filename
*		main.h
*
* Description:
*
* NOTE       :
*
* Revision History:
*		Khaled Saab 	27 Dec 2011		Creation date
****************************************************************************/
#ifndef _MAIN_H__
#define _MAIN_H__


//-----------------------------------------------------------------------
// Include
//-----------------------------------------------------------------------
//RTL, ISR and tasks are not part of the bootloader
#ifndef BOOTLOADER
#include <rtl.h>
#endif

#include <stdint.h>
#include <inc/hw_ints.h>
#include <inc/hw_types.h>


//-------------------------------------------------------------------------
// Compile flags
//-------------------------------------------------------------------------
typedef struct statCortex_t {
	uint32_t statReset;					//reset stat if TRUE; self clearing
	uint32_t packetRxFromEthernet;	 	//packets received from ethernet port
	uint32_t packetRxFromEthernet_fail;	//packets failed to be received
	uint32_t packetTxToEthernet;	 	//packets send to ethernet port
	uint32_t packetTxToEthernet_fail;	//packets that failed to go out of the
										//ethernet port (memory alignment)

	uint32_t packetRxFromUART0;		 	//packets received from UART0 port
	uint32_t packetRxFromUART0_fail;	//packets failed to be received
	uint32_t packetTxToUART0;	 		//packets send to UART0 port
	uint32_t packetTxToUART0_fail; 		//packets send to UART0 port failed

	uint32_t packetRxFromFlash1;	 	//packets received from Flash
	uint32_t packetRxFromFlash1_fail;	//packets failed to be received
	uint32_t packetTxToFlash1;	 		//packets send to Flash
	uint32_t packetTxToFlash1_fail; 	//packets send to Flash failed

	uint32_t packetRxFromFlash2;	 	//packets received from Flash
	uint32_t packetRxFromFlash2_fail;	//packets failed to be received
	uint32_t packetTxToFlash2;	 		//packets send to Flash
	uint32_t packetTxToFlash2_fail; 	//packets send to Flash failed

	uint32_t packetTxToDSP;			 	//packets sent to DSP/core5
	uint32_t packetTxToDSP_fail;	 	//packets sent to DSP/core5 failed
	uint32_t packetRxFromDSP;			//packets received from DSP/core5
	uint32_t packetRxFromDSP_fail;		//packets received from DSP/core5 that failed

	uint32_t dacRxFromDSP;				//Dac samples received from DSP/core5
	uint32_t dacRxFromDSP_fail;			//Dac samples received from DSP/core5 failed
	uint32_t dacTxFromCortex;			//Dac samples transmitted to power line
	uint32_t dacTxFromCortex_fail;		//Dac samples transmitted to power line failed
	uint32_t adcTxToDSP;				//Adc samples transmitted to DSP/core5
	uint32_t adcTxToDSP_fail;			//Adc samples transmitted to DSP/core5 failed

	uint32_t snmpRx;					//SNMP messages received by the Cortex
	uint32_t snmpRx_fail;				//SNMP messages received with errors
	uint32_t snmpTx;					//SNMP messages transmitted by the Cortex
	uint32_t snmpTx_fail;				//SNMP messages transmitted with errors
}STAT_CORTEX;

extern STAT_CORTEX    gStatCortex;	//log Cortex statistics
extern const uint32_t gSwVersion;	//software version number
extern       uint32_t gBdVersion;	//board version number
extern       uint32_t gHwVersion;	//Cortex version number

#ifndef BOOTLOADER
extern OS_MUT 	      gMutexFlag;	//Mutex used to make the tasks atomic
#endif

//-----------------------------------------------------------------------
// Variables redeclaration
//-----------------------------------------------------------------------
extern uint16_t gTxMode;   //TRUE if its Tx mode and FALSE otherwise
extern uint16_t gRxMode;   //TRUE if its Rx mode and FALSE otherwise

//-----------------------------------------------------------------------
//function declaration
//-----------------------------------------------------------------------
void statInit(void);


#endif //_MAIN_H__
